aboutsummaryrefslogtreecommitdiffstats
path: root/gocoverage.sh
diff options
context:
space:
mode:
authorobscuren <geffobscura@gmail.com>2014-12-20 09:34:12 +0800
committerobscuren <geffobscura@gmail.com>2014-12-20 09:34:12 +0800
commit3983dd2428137211f84f299f9ce8690c22f50afd (patch)
tree3a2dc53b365e6f377fc82a3514150d1297fe549c /gocoverage.sh
parent7daa8c2f6eb25511c6a54ad420709af911fc6748 (diff)
parent0a9dc1536c5d776844d6947a0090ff7e1a7c6ab4 (diff)
downloadgo-tangerine-3983dd2428137211f84f299f9ce8690c22f50afd.tar
go-tangerine-3983dd2428137211f84f299f9ce8690c22f50afd.tar.gz
go-tangerine-3983dd2428137211f84f299f9ce8690c22f50afd.tar.bz2
go-tangerine-3983dd2428137211f84f299f9ce8690c22f50afd.tar.lz
go-tangerine-3983dd2428137211f84f299f9ce8690c22f50afd.tar.xz
go-tangerine-3983dd2428137211f84f299f9ce8690c22f50afd.tar.zst
go-tangerine-3983dd2428137211f84f299f9ce8690c22f50afd.zip
Merge branch 'release/v0.7.10'vv0.7.10
Diffstat (limited to 'gocoverage.sh')
-rwxr-xr-xgocoverage.sh29
1 files changed, 29 insertions, 0 deletions
diff --git a/gocoverage.sh b/gocoverage.sh
new file mode 100755
index 000000000..35038108b
--- /dev/null
+++ b/gocoverage.sh
@@ -0,0 +1,29 @@
+#!/bin/bash
+# The script does automatic checking on a Go package and its sub-packages, including:
+# 6. test coverage (http://blog.golang.org/cover)
+
+set -e
+
+# Run test coverage on each subdirectories and merge the coverage profile.
+
+echo "mode: count" > profile.cov
+
+# Standard go tooling behavior is to ignore dirs with leading underscors
+for dir in $(find . -maxdepth 10 -not -path './.git*' -not -path '*/_*' -type d);
+do
+if ls $dir/*.go &> /dev/null; then
+ # echo $dir
+ go test -covermode=count -coverprofile=$dir/profile.tmp $dir
+ if [ -f $dir/profile.tmp ]
+ then
+ cat $dir/profile.tmp | tail -n +2 >> profile.cov
+ rm $dir/profile.tmp
+ fi
+fi
+done
+
+go tool cover -func profile.cov
+
+# To submit the test coverage result to coveralls.io,
+# use goveralls (https://github.com/mattn/goveralls)
+# goveralls -coverprofile=profile.cov -service=travis-ci